searchData={"items":[{"type":"module","title":"NodeJS","doc":"","ref":"NodeJS.html"},{"type":"function","title":"NodeJS.call/3","doc":"","ref":"NodeJS.html#call/3"},{"type":"function","title":"NodeJS.call!/3","doc":"","ref":"NodeJS.html#call!/3"},{"type":"function","title":"NodeJS.start_link/1","doc":"","ref":"NodeJS.html#start_link/1"},{"type":"function","title":"NodeJS.stop/0","doc":"","ref":"NodeJS.html#stop/0"},{"type":"module","title":"NodeJS.Supervisor","doc":"NodeJS.Supervisor","ref":"NodeJS.Supervisor.html"},{"type":"function","title":"NodeJS.Supervisor.call/3","doc":"","ref":"NodeJS.Supervisor.html#call/3"},{"type":"function","title":"NodeJS.Supervisor.call!/3","doc":"","ref":"NodeJS.Supervisor.html#call!/3"},{"type":"function","title":"NodeJS.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NodeJS.Supervisor.html#child_spec/1"},{"type":"function","title":"NodeJS.Supervisor.start_link/1","doc":"Starts the Node.js supervisor and workers.","ref":"NodeJS.Supervisor.html#start_link/1"},{"type":"function","title":"Options - NodeJS.Supervisor.start_link/1","doc":"* `:name` - (optional) The name used for supervisor registration. Defaults to Elixir.NodeJS.Supervisor.\n  * `:path` - (required) The path to your Node.js code's root directory.\n  * `:pool_size` - (optional) The number of workers. Defaults to 4.","ref":"NodeJS.Supervisor.html#start_link/1-options"},{"type":"function","title":"NodeJS.Supervisor.stop/0","doc":"Stops the Supervisor and underlying node service","ref":"NodeJS.Supervisor.html#stop/0"},{"type":"module","title":"NodeJS.Worker","doc":"A genserver that controls the starting of the node service","ref":"NodeJS.Worker.html"},{"type":"function","title":"NodeJS.Worker.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NodeJS.Worker.html#child_spec/1"},{"type":"function","title":"NodeJS.Worker.start_link/2","doc":"Starts the Supervisor and underlying node service.","ref":"NodeJS.Worker.html#start_link/2"},{"type":"exception","title":"NodeJS.Error","doc":"Error when Node.js sends back an error.","ref":"NodeJS.Error.html"},{"type":"extras","title":"NodeJS","doc":"# NodeJS\n\n[![Build Status](https://travis-ci.org/revelrylabs/elixir-nodejs.svg?branch=master)](https://travis-ci.org/revelrylabs/elixir-nodejs)\n[![Hex.pm](https://img.shields.io/hexpm/dt/nodejs.svg)](https://hex.pm/packages/nodejs)\n[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)\n[![Coverage Status](https://opencov.prod.revelry.net/projects/14/badge.svg)](https://opencov.prod.revelry.net/projects/14)\n\nProvides an Elixir API for calling Node.js functions.","ref":"readme.html"},{"type":"extras","title":"Documentation - NodeJS","doc":"The docs can\nbe found at [https://hexdocs.pm/nodejs](https://hexdocs.pm/nodejs).","ref":"readme.html#documentation"},{"type":"extras","title":"Prerequisites - NodeJS","doc":"- Elixir >= 1.7\n- NodeJS >= 10","ref":"readme.html#prerequisites"},{"type":"extras","title":"Installation - NodeJS","doc":"```elixir\ndef deps do\n  [\n    {:nodejs, \"~> 2.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Starting the service - NodeJS","doc":"Add `NodeJS` to your Supervisor as a child, pointing the required `path` option at the\ndirectory containing your JavaScript modules.\n\n```elixir\nsupervisor(NodeJS, [[path: \"/node_app_root\", pool_size: 4]])\n```","ref":"readme.html#starting-the-service"},{"type":"extras","title":"Debug Mode - NodeJS","doc":"When working with Node.js applications, you may encounter debug messages or warnings from the Node.js runtime, especially when using inspector or debugging tools. To properly handle these messages:\n\n```elixir\n# In your config/dev.exs or other appropriate config file\nconfig :nodejs, debug_mode: true\n```\n\nWhen `debug_mode` is enabled:\n- Node.js stdout/stderr messages will be logged at the info level\n- Messages like \"Debugger listening on...\" will not cause errors\n- All Node.js processes will log their output through Elixir's Logger\n\nThis is particularly useful during development or when debugging Node.js integration issues.","ref":"readme.html#debug-mode"},{"type":"extras","title":"Calling JavaScript module functions with `NodeJS.call(module, args \\\\ [])`. - NodeJS","doc":"If the module exports a function directly, like this:\n\n```javascript\nmodule.exports = (x) => x\n```\n\nYou can call it like this:\n\n```elixir\nNodeJS.call(\"echo\", [\"hello\"]) #=> {:ok, \"hello\"}\n```\n\nThere is also a `call!` form that throws on error instead of returning a tuple:\n\n```elixir\nNodeJS.call!(\"echo\", [\"hello\"]) #=> \"hello\"\n```\n\nIf the module exports an object with named functions like:\n\n```javascript\nexports.add = (a, b) => a + b\nexports.sub = (a, b) => a - b\n```\n\nYou can call them like this:\n\n```elixir\nNodeJS.call({\"math\", :add}, [1, 2]) # => {:ok, 3}\nNodeJS.call({\"math\", :sub}, [1, 2]) # => {:ok, -1}\n```\n\nIn order to cope with Unicode character it is necessary to specify the `binary` option:\n\n```elixir\nNodeJS.call(\"echo\", [\"’\"], binary: true) # => {:ok, \"’\"}\n```","ref":"readme.html#calling-javascript-module-functions-with-nodejs-call-module-args"},{"type":"extras","title":"There Are Rules & Limitations (Unfortunately) - NodeJS","doc":"- Function arguments must be serializable to JSON.\n- Return values must be serializable to JSON. (Objects with circular references will definitely fail.)\n- Modules must be requested relative to the `path` that was given to the `Supervisor`.\n  E.g., for a `path` of `/node_app_root` and a file `/node_app_root/foo/index.js` your module request should be for `\"foo/index.js\"` or `\"foo/index\"` or `\"foo\"`.","ref":"readme.html#there-are-rules-limitations-unfortunately"},{"type":"extras","title":"Running the tests - NodeJS","doc":"Since the test suite requires npm dependencies before you can run the tests you will first need to run\n\n  ```bash\n  cd test/js && npm install && cd ../..\n  ```\n\n  After that you should be able to run\n\n  ```bash\n  mix test\n  ```","ref":"readme.html#running-the-tests"},{"type":"extras","title":"Handling Callbacks and Promises - NodeJS","doc":"You can see examples of using promises in the tests here:\n\nhttps://github.com/revelrylabs/elixir-nodejs/blob/master/test/nodejs_test.exs#L125\n\nand from the JavaScript code here:\n\n```\nmodule.exports = async function echo(x, delay = 1000) {\n  return new Promise((resolve) => setTimeout(() => resolve(x), delay))\n}\n```\n\nhttps://github.com/revelrylabs/elixir-nodejs/blob/master/test/js/slow-async-echo.js","ref":"readme.html#handling-callbacks-and-promises"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,51,46,48]}}